package at.reisinger.server.helper;

import at.reisinger.Card;
import at.reisinger.Cards;
import at.reisinger.Package;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.core.type.TypeReference;
import com.fasterxml.jackson.databind.ObjectMapper;

import java.util.ArrayList;
import java.util.Map;

/**
 * Hilfsfunktionen für Jackson Json
 */
public class JsonHelper {

    /**
     * Wandelt ein Package in form einer ArrayList<Card> om ein Json um
     * @param listCards Cards die in dem Json stehen sollen
     * @param name Name des Packages
     * @return Json String des Packages
     */
    public static String packageListToJson(ArrayList<Card> listCards, String name){
        Package packageCards = new Package(new Cards(listCards),name, 5);
        return packageToJson(packageCards);
    }

    /**
     * Wandelt ein Package Objekt in ein Json um
     * @param packageCards Package Objekt das in ein Json umgewandelt werden soll
     * @return Json String des Packages
     */
    public static String packageToJson(Package packageCards){
        ObjectMapper objectMapper = new ObjectMapper();
        objectMapper = new ObjectMapper();
        String packageJson = "";
        if(packageCards != null) {
            try {
                packageJson += objectMapper.writeValueAsString(packageCards);
            } catch (JsonProcessingException e) {
                packageJson = "Error: JsonProcessingException -> " + e.getMessage();
            }
            return packageJson;
        }else{
            return null;
        }
    }

    public static Map<String, Object> jsonPayload2ToMap(String payload){
        ObjectMapper objectMapper = new ObjectMapper();
        try {
            return objectMapper.readValue(payload, new TypeReference<Map<String,Object>>(){});
        } catch (JsonProcessingException e) {
            e.printStackTrace();
            return null;
        }
    }

}
